<style scoped>
  .addFreightRule .form-box {
    background: #fff;
    padding: 20px 50% 20px 0;
    margin-top: 10px;
  }
  .addFreightRule .prompt{
    margin: -10px 20px 20px;
    background-color: #F4F4F5;
    padding: 10px 15px;
    color: #909399;
    display: inline-block;
    font-size: 13px;
  }
  .addFreightRule .gez_list{
    width: 650px;
    margin-bottom: 12px;
    padding: 20px;
    border: 1px solid #EBEEF5;
    background-color: #FFF;
    color: #303133;
    display: flex;
    flex-direction: row;
    justify-content: space-between;

  }
  .addFreightRule .imgstyle{
    width: 32px;
    height: 32px;
    margin: 0 5px;
  }
  .addFreightRule .quyu{
    background-color: #f4f4f5;
    color: #909399;
    padding: 10px;
    line-height: 30px;
    height: 30px;
    font-size: 12px;
    border-radius: 4px;
    white-space: nowrap;
    margin: 5px;
  }
  .addFreightRule .xie{
    margin: 0 5px;
  }

</style>
<template>
  <div class="addFreightRule">
      <div class="form-box">
          <div>
            <span style="color: rgb(64, 158, 255);cursor: pointer;margin-left: 20px" @click="cancel">运费规则</span>
            <span style="margin: 0 5px;color: #C0C4CC;">/</span>
            <span>添加规则</span>
          </div>
      </div>
      <div id="pane-first">
        <div class="form-box">
          <el-form :model="msg" style="padding:0 50px;" :rules="rules" ref="msg" label-width="90px">
            <el-form-item label="规则名称" prop="RulesName" class="is-required">
              <el-input v-model="msg.RulesName"/>
            </el-form-item>
            <el-form-item label="计费方式">
              <el-radio-group v-model="msg.ChargeMode" >
                <el-radio :label="1">按重计费</el-radio>
                <el-radio :label="2">按件计费</el-radio>
              </el-radio-group>
            </el-form-item>
            <el-form-item label="运费规则"  class="is-required">
              <div class="gez_list el-card" v-for="(item,index) in msg.Detail" :key="index">
                <div style="width: 500px;">
                  <span>首重/件(克/个):{{item.First}} <span  class="xie">/</span> 首费(元):{{item.FirstPrice}} <span class="xie">/</span>续重/件(克/个):{{item.Second}}<span  class="xie">/</span>续费(元){{item.SecondPrice}}</span>
                  <div>区域：<span v-for="(item2,index2) in item.List" :key="index2" class="quyu">
                    {{item2.RegionName}}</span>
                  </div>

                </div>
                <div style="width: 110px;display: flex;flex-direction: row;justify-content: space-around">
                  <el-tooltip class="item" effect="dark" content="编辑" placement="top" >
                    <img src="../../assets/img/setup/edit.png" alt="" class="imgstyle" @click="edit(index,item)">
                  </el-tooltip>
                  <el-tooltip class="item" effect="dark" content="删除" placement="top">
                    <img src="../../assets/img/setup/del.png" alt="" class="imgstyle" @click="delete_b(index)">
                  </el-tooltip>
                </div>
              </div>
                <span style="color: #409EFF;font-size: 14px;cursor: pointer;" @click="addOf">+新增规则</span>
            </el-form-item>
          </el-form>

        </div>
        <el-button type="primary" style="margin: 12px 0 " @click="preserve">保存</el-button>
        <el-button style="margin: 12px 0 " @click="cancel">取消</el-button>

      </div>

    <!--新增规则弹窗-->
      <el-dialog title="新增规则" :visible.sync="dialogFormVisible" >
        <el-form :rules="rules">
          <el-row :gutter="0">
            <el-col :span="11" >
              <el-form-item label="首重(克)：" label-width="100px" style="padding: 0px 1rem;"  prop="First">
                <el-input v-model="First" step="1"  min="0" onkeyup="this.value= this.value.match(/\d+(\.\d{0,2})?/) ? this.value.match(/\d+(\.\d{0,2})?/)[0] : ''" />
              </el-form-item>
            </el-col>
            <el-col :span="11">
              <el-form-item label="首费（元）" label-width="100px" style="padding: 0px 1rem;" prop="FirstPrice">
                <el-input v-model="FirstPrice" step="1"  min="0" onkeyup="this.value= this.value.match(/\d+(\.\d{0,2})?/) ? this.value.match(/\d+(\.\d{0,2})?/)[0] : ''" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row :gutter="0">
            <el-col :span="11">
              <el-form-item label="续重(克)：" label-width="100px" style="padding: 0px 1rem;" prop="Second">
                <el-input v-model="Second" step="1"  min="0" onkeyup="this.value= this.value.match(/\d+(\.\d{0,2})?/) ? this.value.match(/\d+(\.\d{0,2})?/)[0] : ''" />
              </el-form-item>
            </el-col>
            <el-col :span="11">
              <el-form-item label="续费（元）" label-width="100px" style="padding: 0px 1rem;" prop="SecondPrice">
                <el-input v-model="SecondPrice" step="1"  min="0" onkeyup="this.value= this.value.match(/\d+(\.\d{0,2})?/) ? this.value.match(/\d+(\.\d{0,2})?/)[0] : ''" />
              </el-form-item>
            </el-col>
          </el-row>

          <el-form-item label="地区选择">
            <region_Choice @event1="change($event)" :List="List" ref="child"></region_Choice>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogFormVisible = false">取 消</el-button>
          <el-button type="primary" @click="Addto">确 定</el-button>
        </div>
      </el-dialog>
  </div>
</template>

<script>
  import region_Choice from './view/regionChoice'
    export default {
        name: "addFreightRule",
        data(){
          return{
            msg:{
              ID:0,
              RulesName:'',
              ChargeMode:1,
              Detail:[],
            },
            First:0,
            FirstPrice:0,
            Second:0,
            SecondPrice:0,
            List:[],

            isedit:false,
            editindex:0,
            dialogFormVisible:false,
            rules: {
              RulesName: [
                {required: true, message: "请输入规则名称", trigger: "blur"}
              ],
              First:[
                { validator: this.isNumber, trigger: 'blur' }
              ],
              FirstPrice:[
                { validator: this.isNumber, trigger: 'blur' }
              ],
              Second:[
                { validator: this.isNumber, trigger: 'blur' }
              ],
              SecondPrice:[
                { validator: this.isNumber, trigger: 'blur' }
              ],

            },
          }
      },
      created(){
        if(this.$route.query.ID){
            this.getLogisticsRules(this.$route.query.ID)
        }
      },
      components:{
        region_Choice,
      },
      methods:{
        cancel(){
          this.$router.go(-1);//返回上一层
        },

        addRule(){

        },
        getLogisticsRules(ID){//编辑时获取详情数据
          this.apipost("/api/MallBase/GetLogisticsRules",{'ID':ID} , res => {
            if (res.data.resultCode == 1) {
                this.msg =res.data.data
            } else {
              this.Info(res.data.message);
            }
          })
        },
        change(data){
          let List=[];
          for(let i=0 ;i<data.length;i++){
              if(data[i].ischeckAll==true && data[i].indeterminate==false){ //全选的情况 只穿省的ID
                List.push({'ID':0,'RegionId':data[i].ID,"RegionName":data[i].Name,'GrandpaID':0,'ParentID':0})
              }
              if(data[i].indeterminate==true){//传市的ID

                if(data[i].hasOwnProperty('cityList')==true){
                  let citylist = data[i].cityList;
                  for(let j= 0;j<citylist.length;j++){
                    if(citylist[j].ischeckAll==true && citylist[j].indeterminate==false){
                      List.push({'ID':0,'RegionId':citylist[j].ID,"RegionName":citylist[j].Name,'GrandpaID':0,'ParentID':data[i].ID})
                    }
                    if(citylist[j].indeterminate==true){
                      if(citylist[j].hasOwnProperty('areaList')==true){
                        let areaList = citylist[j].areaList;
                        for(let z= 0;z<areaList.length;z++){
                          if(areaList[z].ischeckAll==true){
                            List.push({'ID':0,'RegionId':areaList[z].ID,"RegionName":areaList[z].Name,'GrandpaID':data[i].ID,'ParentID':citylist[j].ID})
                          }
                        }
                      }

                    }
                  }

                }
              }
          }

          this.List = List;

        },
        delete_b(index){
          this.msg.Detail.splice(index,1)
        },
        edit(index,data){
          this.isedit=true;//设置为编辑状态
          this.editindex=index;//编辑的索引

          this.First=data.First;
          this.FirstPrice=data.FirstPrice;
          this.Second=data.Second;
          this.SecondPrice=data.SecondPrice;
          this.List=data.List;
          this.dialogFormVisible=true;
          setTimeout(()=>{
                  this.$refs.child.Receive(this.List)
          },1000)

        },
        addOf(){
          this.First=0;
          this.FirstPrice=0;
          this.Second=0;
          this.SecondPrice=0;
          this.List=[];
          this.dialogFormVisible=true
          setTimeout(()=>{
            this.$refs.child.Receive(this.List)
          },1000)
        },
        Addto(){
          this.dialogFormVisible=false


          let First = parseInt(this.First);
          let FirstPrice = parseInt(this.FirstPrice);
          let Second = parseInt(this.Second);
          let SecondPrice = parseInt(this.SecondPrice);

          let Detail = {
            'ID':0,
            'First':First,
            'FirstPrice':FirstPrice,
            'Second':Second,
            'SecondPrice':SecondPrice,
            'List':this.List,
          }

          if( this.isedit==true){
            this.msg.Detail[this.editindex] =Detail;
            this.isedit=false //编辑之后复原
          }else {
            this.msg.Detail.push(Detail)
          }



        },
        preserve(){
          this.apipost("/api/MallBase/AddOrUpdateLogisticsRules",this.msg , res => {
            if (res.data.resultCode == 1) {
              this.Success(res.data.message);
              this.$router.push({
                name: 'ruleSetup',
                query: {
                  activeName:'second',
                  blank: "y"
                }
              });
            } else {
              this.Info(res.data.message);
            }
          })
        },
        isNumber(rule, value, callback) {

          if (value === '') {
            return callback();
          }  //这是用来判断如果不是必须输入的，则直接跳出
          const r = /^[0-9]*$/; // 正整数
          // 如果判断不符合正则，则不是正整数不能提交
          if (!r.test(value)) {
            return callback(new Error('请输入数字'));
          } else {
            return callback();
          }

        },
      },


    }
</script>


